//
//  CFGSocket.h
//
//  FGHelloDevice
//
//  Created by Francesco on 5/4/06.
//  Copyright 2006 Softech di Germinara Francesco. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <netinet/in.h>  //per la dichiarazione di sockaddr_in (kernel framework)

// TCP I/O command definition
#define IOGet			0x75
#define IOSet			0x76

#define outBit_ON	 		1
#define outBit_OFF	 	0
#define inpBit_ON	 		0
#define inpBit_OFF	 	1


// Utilizzata per Convertire i dati da Byte in Bits e Viceversa 
union{
 struct{
  unsigned char low:4;
  unsigned char high:4;
 }nibble;
 struct{
  unsigned char b0:1;
  unsigned char b1:1;
  unsigned char b2:1;
  unsigned char b3:1;
  unsigned char b4:1;
  unsigned char b5:1;
  unsigned char b6:1;
  unsigned char b7:1;
 }bit;
 unsigned char byte;
}dato;

// Utilizzata per Convertire i dati da WORD a BYTES e Viceversa
union udataword{
 struct dataword{
  unsigned char lsb;
  unsigned char msb;  
 }bytes;
 unsigned short int dw;
}word;

//Definisco il tipo di dato DWStatus
typedef union udataword DWStatus;

@interface CFGSocket : NSObject {

struct sockaddr_in addr ;		// My IP address
struct sockaddr_in clientAddr;	// HelloDevice IP address
unsigned int ipAddr;	// IP address input
int clientLenght;

@public

//Primi 2 bytes Input (0,1) i successivi (2,3) Output
union{
 unsigned char IOStatus[4]; 
 struct{
  DWStatus input;
  DWStatus output; 
 }porta;
}StatoIO;

BOOL m_OpenConnection; //TRUE=A connection is open 
unsigned int idFile; //File descriptor
}

- (id) init; //Costruttore
- (void) dealloc; //Distruttore
- (BOOL) CreateSocket:(NSString*) ipAddress withPort:(unsigned int) port; //Crea il Socket per la comunicazione
- (void)initDevice:(NSString*) ipAddress withPort:(unsigned int) port; //inizializzo la scheda
- (BOOL) ReadStatus; //Read Input e Output 
- (void) SetBit:(int) nBit withStatus:(BOOL) sts; //Imposto il Bit specificato 0-15 allo stato ON/OFF 1-0
- (void) SetBitAsString:(NSString*) strNBit withStatus:(BOOL) sts; //Imposto il Bit specificato 0-15 allo stato ON/OFF 1-0 usando una stringa
- (BOOL) GetBit:(int) nBit; //Restituisce lo stato del bit indicato (0-15)
- (BOOL) GetBitAsString:(NSString*) strNBit; //Restituisce lo stato del bit indicato (0-15) usando una stringa 
- (NSString*) ShowInputStatus; //Restituisce una stringa con le indicazioni dello stato dei singolo bit di Input
- (NSString*) ShowOutputStatus; //Restituisce una stringa con le indicazioni dello stato dei singolo bit di Output
- (BOOL) SetOutput; //Attivo gli output sulla scheda
- (BOOL) GetInputStatus:(int) nBit useInvertedState:(BOOL) bInverted; //Leggo lo stato di un bit della scheda se useInvertedState=TRUE il valore e' invertito
- (BOOL) GetOutputStatus:(int) nBit; //Leggo lo stato del bit di output
- (void) SetOutputStatus:(int) nBit withStatus:(BOOL) status; //Imposto uno specifico bit di output. Il dato sara' inviato alla scheda solo con SetOutput
- (void) SetAllOutputStatus:(BOOL) status; //Invia il comando SetOutput con il valore indicato a tutte e 16 gli output 
- (void) CloseConnection; //Close the connection

@end
